=== debian/changelog ===
pcp (7.0.3-1) unstable; urgency=high

  * New release (full details in CHANGELOG).
  * Exclude pmdabcc ppc64el builds until bpfcc #1077087 resolved (closes: #1117010)
  * Fix pmlogger.service "protocol-error" issue [some time ago] (closes: #1005325)
  * Use libinih-dev where available [done some time ago] (closes: #958241)
  * Resolve install-doc --check issue [some time ago] (closes: #971414)
  * Add perl-xs-dev to Build-Depends for trixie or later (closes: #1102849)

 -- Nathan Scott <nathans@debian.org>  Wed, 12 Nov 2025 09:06:53 +1100

pcp (7.0.2-1) unstable; urgency=low

  * New release (full details in CHANGELOG).
  * Introduces a JSON benchmark results format-converter package.

 -- Nathan Scott <nathans@debian.org>  Wed, 15 Oct 2025 17:52:14 +1000
