## pcp 7.0.4

=== debian/changelog ===
pcp (7.0.4-1) unstable; urgency=high

  * New release (full details in CHANGELOG).

 -- Nathan Scott <nathans@debian.org>  Thu, 20 Nov 2025 09:17:30 +1100
