## pcp 7.0.5

=== debian/changelog ===
pcp (7.0.5-1) unstable; urgency=high

  * New release (full details in CHANGELOG).

 -- Nathan Scott <nathans@debian.org>  Fri, 21 Nov 2025 11:08:59 +1100
