=== debian/control ===
--- 
+++ 
@@ -71,8 +71,7 @@
 Package: libpcp4
 Depends: ${shlibs:Depends}, ${misc:Depends}, pcp-conf (= ${binary:Version})
 Conflicts: pgpool2
-Breaks: pcp (<< 2.8.0), libpcp3-dev (<< 2.8.5), libpcp3t64 (<< 6.3.2)
-Replaces: libpcp3t64 (<< 6.3.2)
+Breaks: pcp (<< 2.8.0), libpcp3-dev (<< 2.8.5)
 Section: libs
 Architecture: any
 Description: Performance Co-Pilot library
@@ -110,8 +109,6 @@
 
 Package: libpcp-gui2
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Breaks: libpcp-gui2t64 (<< 6.3.2)
-Replaces: libpcp-gui2t64 (<< 6.3.2)
 Section: libs
 Architecture: any
 Description: Performance Co-Pilot graphical client tools library
@@ -139,8 +136,6 @@
 
 Package: libpcp-mmv1
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Breaks: libpcp-mmv1t64 (<< 6.3.2)
-Replaces: libpcp-mmv1t64 (<< 6.3.2)
 Section: libs
 Architecture: any
 Description: Performance Co-Pilot Memory Mapped Value client library
@@ -173,8 +168,6 @@
 
 Package: libpcp-pmda3
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Breaks: libpcp-pmda3t64 (<< 6.3.2)
-Replaces: libpcp-pmda3t64 (<< 6.3.2)
 Section: libs
 Architecture: any
 Description: Performance Co-Pilot Domain Agent library
@@ -201,8 +194,6 @@
 
 Package: libpcp-trace2
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Breaks: libpcp-trace2t64 (<< 6.3.2)
-Replaces: libpcp-trace2t64 (<< 6.3.2)
 Section: libs
 Architecture: any
 Description: Performance Co-Pilot application tracing library
@@ -232,8 +223,6 @@
 
 Package: libpcp-import1
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Breaks: libpcp-import1t64 (<< 6.3.2)
-Replaces: libpcp-import1t64 (<< 6.3.2)
 Section: libs
 Architecture: any
 Description: Performance Co-Pilot data import library
@@ -263,4 +252,16 @@
 
 Package: libpcp-web1
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Breaks: libpcp-web1t64 (<< 6.3.2)
+Section: libs
+Architecture: any
+Description: Performance Co-Pilot data import library
+ The libpcp-web1 package contains the runtime environment required
+ by a PMDA to parse and extract metric data from a JSON file.
+ .
+ The Performance Co-Pilot provides a unifying abstraction for
+ all of the interesting performance data in a system, and allows
+ client applications to easily retrieve and process any subset of
+ that data.
+
+Package: libpcp-archive1-dev
+Section: libdevel
